/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.geoviewer;

import org.geotools.coverage.grid.GridCoverage2D;

/**
 * Basic Raster implementation of the Layer-interface.
 * 
 * The basis for a RasterLayer on a map.
 * 
 * @author Timon Veenstra
 */
@Deprecated
public abstract class RasterLayer extends BaseLayer implements Rastered {

    private GridCoverage2D raster;
    public static final String PROPERTY_RASTER = "raster";

    public RasterLayer(Palette palette, String name) {
        super(palette,  name);
    }

    public RasterLayer(Palette palette, String name, GridCoverage2D raster) {
        super(palette, name);
        this.raster = raster;
    }

    /**
     * @see Rastered#getRaster
     * @return Raster as GridCoverage2D
     */
    @Override
    public GridCoverage2D getRaster() {
        return this.raster;
    }

    /**
     * Set the raster for this Layer
     * @param raster The raster to set to this Layer
     */
    public void setRaster(GridCoverage2D raster) {
        GridCoverage2D old = this.raster;
        this.raster = raster;
        getChangeSupport().firePropertyChange(PROPERTY_RASTER, old, raster);
    }

    /**
     * Gets the object the raster is based on
     * @return the object the raster is based on
     */
    public abstract Class getObjectClass();
}
